# crt0.s by Titanik / Crazy Nation  22/7/2003	
# GC init code, note that the APPLOADER initializes the CPU and most of the 
# stuff, so init code can be really small

	.text
	.global	_start
	.func	_start	
_start:
    lis   1,0x8000    # SP = arena_hi -4
    lwz   1,0x34(1) 
    subi  1,1,4

    mfmsr 0           # oops, forgot it ;-)
    ori   0, 0, 0x2000 
    mtmsr 0
    mfspr 3, 0x398    
    oris  3, 3, 0xA000
    mtspr 0x398,3
    mfspr 3, 0x3F0    # hid0
    oris  3, 3, 0xC800
    mtspr 0x3F0,3
    sync
    
    li    3,0         # argc
    li    4,0         # argv
    li    18,0        # filesize
    li    19,0        # fileaddr
    lis   5,0x8000
    lwz   5,0xf4(5)
    cmpwi 5,0
    beq   noparams    # no bootinfo2
    
    lwz   6,0x10(5)   # PSUL bootinfo
    lis   7,0x5053
    ori   7,7,0x554c
    cmpw  6,7
    bne   nopbi       # no PSUL bootinfo
    lwz   18,0x18(5)  # load filesize
    lwz   19,0x14(5)  # load fileaddr
    
nopbi:                    
    lwz   6,0x8(5)
    cmpwi 6,0
    beq   noparams    # no params in bi2
    add   6,6,5
    lwz   3,0(6)
    cmpwi 3,0
    beq   noparams    # no params in bi2
    mtctr 3
    addi  4,6,4
argvreloc: 
    lwzu  7,4(6)
    add   7,7,5
    stw   7,0(6)    
    bdnz  argvreloc
    
noparams:    
    mr    5,18
    mr    6,19
    bl    main
    
hello:
    b     hello
    
.endfunc

